declare
fun {Conference Data}
   NbSessions   = Data.nbSessions
   NbSalles     = Data.nbSalles
   Constraints  = Data.constraints
   MinNbSlots   = NbSessions div NbSalles
in 
   proc {$ Plan}
      NbSlots = {FD.int MinNbSlots#NbSessions}
   in 
      {FD.distribute naive [NbSlots]}
      {Browse NbSlots}
      %% Plan: Session --> Slot
      {FD.tuple plan NbSessions 1#NbSlots Plan}
      %% at most NbSalles sessions per slot
      for Slot in 1..NbSlots do   
	 {FD.atMost NbSalles Plan Slot}
      end
      %% impose constraints
      {ForAll Constraints
       proc {$ C}
          case C
          of before(X Y) then  
             Plan.X <: Plan.Y
          [] disjoint(X Ys) then 
             {ForAll Ys proc {$ Y} Plan.X \=: Plan.Y end}
          end 
       end}
      {FD.distribute naive Plan}
   end 
end 

{Browse {SearchOne {Conference Colloque}}}
